namespace ConsoleApp2
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] prvi = Console.ReadLine().Split();
            int n = int.Parse(prvi[0]);
            int m = int.Parse(prvi[1]);

            int[] a = new int[m];
            int[] b = new int[m];
            int[] t = new int[m];
            int i;
            for(i=0;i<m; i++)
            {
                string[] s = Console.ReadLine().Split();
                a[i] = int.Parse(s[0]);
                b[i] = int.Parse(s[1]);
                t[i] = int.Parse(s[2]);


            }
            string[] drugi = Console.ReadLine().Split();
            int u = int.Parse(drugi[0]);
            int v = int.Parse(drugi[1]);
            int x = 0;
            int y=0;
            if (a[i] <= 0 || b[i] <= 0)
            {
                Console.WriteLine("-1");
            }
            else {
                while (i == m) {
                    if (m == 0)
                    {
                        Console.WriteLine("-1");
                    }
                    else if (t[i] == 1 && y == 0)
                    {
                        x++;
                        y++;
                    }
                    else
                    {
                        x = x + 0;
                    }
                    i++; }
                Console.WriteLine(x); }
        }
    }
}